#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <getopt.h>
#include "libivolektor.h"
#include <locale.h>

struct IVOL_data *ivona;


void help(char *name)
{
    fprintf(stderr,"Usage:\n%s [-H host] [-P port] [-v voice] [-p pauses] [slowo...]\n",name);
    exit(0);
}

int main(int argc,char *argv[])
{
    char *err,*str;
    short *wave;
    int offset,length,brklen;
    double factor=1.0;
    int port=0;
    char *host=NULL;
    char *voice="ewa";
    char buf[256];
    
    for (;;) {
        int copt=getopt(argc,argv,"hv:p:P:H:");
        if (copt < 0) break;
        switch(copt) {
            case 'H':
            host=strdup(optarg);
            continue;
            case 'P':
            port=strtol(optarg,NULL,10);
            continue;
            case 'p':
            factor=strtod(optarg,NULL);
            continue;
            case 'v':
            voice=strdup(optarg);
            continue;
            default:
            help(argv[0]);
        }
    }
    setlocale(LC_MESSAGES,"");
    if (optind >= argc) str="Test testowy";
    else {
        int i,len;
        for (i=optind;i<argc;i++) {
            len+=strlen(argv[i]+1);
        }
        str=malloc(len);
        for (i=optind;i<argc;i++) {
            if (!i) strcpy(str,argv[i]);
            else {
                strcat(str," ");
                strcat(str,argv[i]);
            }
        }
    }
        
    ivona=IVOL_openNetwork(voice,host,port,&err);
    if (!ivona) {
        fprintf(stderr,"%s\n",err);
        exit(1);
    }
    wave=IVOL_getSentence(ivona,str,&offset,&length,&brklen,factor,&err);
    if (!wave) {
        fprintf(stderr,"%s\n",err);
        exit(1);
    }
    sprintf(buf,"play -q -t raw -s -c 1 -r %d -2 -",ivona->freq);
    FILE *f=popen(buf,"w");
    if (f) {
        fwrite(wave+offset,length,2,f);
        pclose(f);
    }
    exit(0);
}

