/*
 * ivol_network.c - part of libivolektor library
 * Copyright (C) Bohdan R. Rau 2011 <ethanak@polip.com>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */


int ivol_InitAddr(char *host,int port,struct sockaddr_in *sinadr)
{
        if (!inet_aton(host,&sinadr->sin_addr)) {
                struct hostent *h = gethostbyname(host);
                if (!h) return 0;
                memcpy(&(sinadr->sin_addr), h->h_addr, sizeof(struct in_addr));
                endhostent();
        }
        sinadr->sin_family = AF_INET;
        sinadr->sin_port = htons(port);
        return 1;
}

FILE *ivol_ConnectFile(struct sockaddr_in *sinadr)
{
    int fd;
    if ((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
        return NULL;
    }
    if (connect(fd, (struct sockaddr *) sinadr, sizeof(*sinadr)) < 0) {
        close(fd);
        return NULL;
    }
    return fdopen(fd,"r+");
}
